//+------------------------------------------------------------------+
//|                                                         easy.mq4 |
//|                                                      TravkinSerg |
//|                                                                  |
//+------------------------------------------------------------------+
#include <VisualTestingTools.mq4>

#property copyright "TravkinSerg"
#property link      ""
#property version   "1.00"
#property strict
//--- input parameters
input int bars=8;
input int lengthSMA=365;
int per; // 
int transaction=0;
datetime barTime;
int count=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   //EventSetTimer(10);
//---
   //Alert ("  ", Action, "  ", Frame, "  ", iBars(Action, Frame), " ");
   vTerminalInit();
   vHistoryInit();
   
   per=Period();
   int nF=NewFrame();
   /*if(nF!=0)
      Alert(nF);
   else
      End();*/
   if(nF==0)
   {
      Alert(".     .");
      Print(".     .");
      End();
   }
   return(INIT_SUCCEEDED);
      /*if(Time[0]!=current_bar_time)
      Alert("OK");
   */
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
      
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void End(){
   ExpertRemove();
}
int NewFrame()
  {
   double highAr[], lowAr[], closeAr[];
   int up=0, down=0;
   int size=200, sizeMA=750;
   barTime=Time[0];
   //Alert(barTime);
   double mA;
   datetime t=iTime(NULL,0,0);
   int cH=CopyHigh(NULL, 0, t, size, highAr);
   int cL=CopyLow(NULL, 0, t, size, lowAr);
   int cC=CopyClose(NULL, 0, t, sizeMA, closeAr);
   if(cH==-1 || cL==-1 || cC==-1)
   {
      Alert("   ",GetLastError());
      Print("   ",GetLastError());
      End();
   }
   int slide=size, slideMA=sizeMA;
   
   while(up<bars && down<bars && size>0)
   {
      slide--;
      slideMA--;
      mA=SMA(slideMA, lengthSMA, closeAr);
      if(highAr[slide]<mA){
         down++;
         up=0;
      }
      if(lowAr[slide]>mA){
         up++;
         down=0;
      }
   }
   if(up==bars)
      return 1;
   if(down==bars)
      return -1;
   
   return 0;
  }
double SMA(const int position,const int period,const double &price[])
  {
//---
   double result=0.0;
//--- check position
   if(position>=period-1 && period>0)
     {
      //--- calculate value
      for(int i=0;i<period;i++) result+=price[position-i];
      result/=period;
     }
//---
   return(result);
  }
void OnTick()
  {
//---
   vTerminalRefresh();
   vHistoryRefresh();
   double price;
   int nF;
   if(per!=Period())
   {
      per=Period();
      Alert(" ");
      nF=NewFrame();
     /*if(nF!=0)
         Alert(nF);
      else
         End();*/
      if(nF==0)
      {
         Alert(".     .");
         Print(".     .");
         End();
      }
   }
   datetime newBarTime=Time[0];
   if(newBarTime!=barTime)
   {
      transaction=0;
      nf=NewFrame();
      if(nF==0)
      {
         Alert(".     .");
         Print(".     .");
         End();
      }
   }
   MqlTick last_tick;
   //Alert(Symbol());
   if(SymbolInfoTick(Symbol(),last_tick))
   {
      price = last_tick.bid;
   }
   else
   { 
      Alert("SymbolInfoTick() failed, error = ",GetLastError());
      Print("SymbolInfoTick() failed, error = ",GetLastError());
      End();
   }
   double ima=iMA(NULL, 0, lengthSMA, 0, MODE_SMA, PRICE_CLOSE, 0);
   if(transaction==0)
   {
      if(nF==1 && price<ima)
      {
         transaction=1;
         /*MqlTradeRequest mrequest; 
         MqlTradeResult mresult;
         mrequest.action=TRADE_ACTION_DEAL;
         mrequest.symbol=NULL;
         mrequest.volume=1;
         mrequest.type=ORDER_TYPE_BUY;
         mrequest.comment=per-(TimeCurrent().min-barTime.min)+bars*per;
         OrderSend(mrequest,mresult);
         */
         int comment=per-(TimeCurrent()-barTime)/60+bars*per;
         int os=OrderSend(NULL,OP_BUY,1,ima,7,0,0,comment,2345,0,clrGreen);
         if(os==-1)
         {
            Alert(".    . ",GetLastError());
            Print(".    . ",GetLastError());
            End();
         }
         count++;
         printf("%d",count);
      }
      if(nF==-1 && price>ima)
      {
         transaction=1;
         /*MqlTradeRequest mrequest;
         MqlTradeResult mresult; 
         mrequest.action=TRADE_ACTION_DEAL;
         mrequest.symbol=NULL;
         mrequest.volume=1;
         mrequest.type=ORDER_TYPE_SELL;
         mrequest.comment=per-(TimeCurrent().min-barTime.min)+bars*per;
         OrderSend(mrequest,mresult);*/
         int comment = per - (TimeCurrent()-barTime)/60 + bars*per;
         int os=OrderSend(NULL,OP_SELL,1,ima,7,0,0,comment,1234,0,clrGreen);
         if(os==-1)
         {
            Alert(".    . ",GetLastError());
            Print(".    . ",GetLastError());
            End();
         }
         count++;
         printf("%d",count);
      }   
   }
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   /*counter++;
   Alert ("", counter, "*10 ");   
  */
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
